% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
%                      _        _       _                _     _    %
%      /\    |\    /| |  \  |  /  \   /   \  |\   | |  /   \  /  \  %
%     /  \   | \  / | |_ /  |  \_    |     | | \  | | |       \_    %
%    /_  _\  |  \/  | |   \ |     \  |     | |  \ | | |          \  %
%   /      \ |      | |_ _/ |  \_ /   \ _ /  |   \| |  \ _ /  \_ /  % 
%                                                                   % 
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
function [X]=Ambisonics(fi, ch, pk, d, mono);

FI= (fi/180) *pi;

% Ambisonicke kodovanie monofonneho zvuku 

W= 1/(sqrt(3.5))* mono;
X= cos(FI)* mono;
Y= sin(FI)* mono;

% Dekodovanie zvuku pre jednotlive reproduktory

gw= sqrt(2);

switch pk
    case 4
        
        % Front Right
        l1= 0.5*((2-d)* gw* W+ d*(cos(ch(1))* X+ sin(ch(1))* Y));

        % Surround Right
        l2= 0.5*((2-d)* gw* W+ d*(cos(ch(2))* X+ sin(ch(2))* Y));

        % Surround Left
        l3= 0.5*((2-d)* gw* W+ d*(cos(ch(3))* X+ sin(ch(3))* Y));

        % Front Left
        l4= 0.5*((2-d)* gw* W+ d*(cos(ch(4))* X+ sin(ch(4))* Y));
        
    case 5
        
        % Center
        l1= 0.5*((2-d)* gw* W+ d*(cos(ch(1))* X+ sin(ch(1))* Y));
        
        % Front Right
        l2= 0.5*((2-d)* gw* W+ d*(cos(ch(2))* X+ sin(ch(2))* Y));        

        % Surround Right
        l3= 0.5*((2-d)* gw* W+ d*(cos(ch(3))* X+ sin(ch(3))* Y));

        % Surround Left
        l4= 0.5*((2-d)* gw* W+ d*(cos(ch(4))* X+ sin(ch(4))* Y));

        % Front Left
        l5= 0.5*((2-d)* gw* W+ d*(cos(ch(5))* X+ sin(ch(5))* Y));
        
     case 6
         
        % Center
        l1= 0.5*((2-d)* gw* W+ d*(cos(ch(1))* X+ sin(ch(1))* Y));
        
        % Front Right
        l2= 0.5*((2-d)* gw* W+ d*(cos(ch(2))* X+ sin(ch(2))* Y));        

        % Surround Right
        l3= 0.5*((2-d)* gw* W+ d*(cos(ch(3))* X+ sin(ch(3))* Y));

        % Extended Surround
        l4= 0.5*((2-d)* gw* W+ d*(cos(ch(6))* X+ sin(ch(6))* Y));

        % Surround Left
        l5= 0.5*((2-d)* gw* W+ d*(cos(ch(4))* X+ sin(ch(4))* Y));

        % Front Left
        l6= 0.5*((2-d)* gw* W+ d*(cos(ch(5))* X+ sin(ch(5))* Y));

end;

switch pk
    
    case 4
        X= [l1; l2; l3; l4];
        
    case 5
        X= [l1; l2; l3; l4; l5];
        
    case 6
        X= [l1; l2; l3; l5; l6; l4];
        
end;
    
