function out = DBAP (speakers,s,l,sb,R, mono)
% Funkce 'DBAP' slouzi k aplikaci DBAP metody panoramovani
% na monofonni signal => vytvori n-kanalovy signal
%
% mono = monofonni signal
% speakers = poloha reproduktoru
% s = poloha zdroje zvuku
% l = poloha posluchace
% sb = Spatial blur - rozptylovy faktor
% R = Rolloff - pokles hladiny akustickeho tlaku zvukoveho pole

% Konstanty
n = length (speakers);         % pocet reproduktoru
a = 10^(-R/20);  % vypocet koeficientu a

% Vypocet vzdalenosti zdroje zvuku od jednotlivych reproduktoru
di= sqrt( (speakers(:,1)-s(1)).^2 + (speakers(:,2)-s(2)).^2 +sb^2 );

% Vypocet vzdalenosti posluchace od jednotlivych reproduktoru 
dl= sqrt(((speakers(:,1)-l(1)).^2)+((speakers(:,2)-l(2)).^2));

% Vypocet koeficientu k
k= 2*a*(sum( 1./(di.^(2*a)))^(-0.5));


% Vypocet zesileni pro jedntlive kanaly

% di= di.^(2);
% g= zeros(1, n);
% for i=1:n
%     g(i)= (sum(di(i)./di)).^(-1);
% end

G= (di*(sum(1./(di).^(2)))).^(-1);

G=G/sqrt(sum(G.^2));

out= G*mono;